//+------------------------------------------------------------------+
//|                                                       Panel2.mqh |
//|                                 Copyright 2015, Vasiliy Sokolov. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Vasiliy Sokolov."
#property link      "http://www.mql5.com"

#include <Trade\MarketBook.mqh>
#include <Trade\Trade.mqh>
#define OP_BUY 0
#define OP_SELL 1
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CDevPanel
  {
private:

   CTrade            Trade;
   string            m_descr_dev;
   string            m_buy_button_name;
   string            m_sell_button_name;
   string            m_deviation_name;
   string            m_volume_name;
   string            m_descr_sl;
   string            m_sl_name;
   string            m_bg_fon;
   string            m_vol_descr;
   string            m_vol_edit;
   int               m_deviation;
   double            m_sl_level;
   long              m_volume;
   void              OnObjClick(string sparam);
   void              OnEndEdit(string sparam);
   double            CalcCurrentPrice(int op_type);
   bool              SendStopLoss(int op_type);
   CMarketBook       MarketBook;
public:
                     CDevPanel();
                    ~CDevPanel();
   void              OnChartEvent(const int id,
                                  const long &lparam,
                                  const double &dparam,
                                  const string &sparam);
   void              OnBookEvent(string symbol);
  };
//+------------------------------------------------------------------+
//| CDevPanel class                                                  |
//+------------------------------------------------------------------+
CDevPanel::CDevPanel(): m_buy_button_name("buy_button"),
                        m_sell_button_name("sell_button"),
                        m_deviation_name("deviation"),
                        m_volume_name("volume"),
                        m_bg_fon("bg_fon"),
                        m_descr_dev("descr_dev"),
                        m_deviation(3),
                        m_sl_name("sl_level"),
                        m_descr_sl("sl_descr"),
                        m_vol_descr("vol_desc"),
                        m_vol_edit("vol_edit"),
                        m_sl_level(0.0),
                        MarketBook(Symbol())
  {
//--- background
   ObjectCreate(0,m_bg_fon,OBJ_RECTANGLE_LABEL,0,0,0);
   ObjectSetInteger(0,m_bg_fon,OBJPROP_YDISTANCE,10);
   ObjectSetInteger(0,m_bg_fon,OBJPROP_YSIZE,110);
   ObjectSetInteger(0,m_bg_fon,OBJPROP_XSIZE,190);
   ObjectSetInteger(0,m_bg_fon,OBJPROP_BGCOLOR,clrWhiteSmoke);

//--- deviation
   ObjectCreate(0,m_deviation_name,OBJ_EDIT,0,0,0);
   ObjectSetInteger(0,m_deviation_name,OBJPROP_XDISTANCE,120);
   ObjectSetInteger(0,m_deviation_name,OBJPROP_YDISTANCE,20);
   ObjectSetInteger(0,m_deviation_name,OBJPROP_XSIZE,60);
   ObjectSetInteger(0,m_deviation_name,OBJPROP_BGCOLOR,clrWhite);
   ObjectSetInteger(0,m_deviation_name,OBJPROP_COLOR,clrBlack);
   ObjectSetInteger(0,m_deviation_name,OBJPROP_ALIGN,ALIGN_RIGHT);
   ObjectSetString(0,m_deviation_name,OBJPROP_TEXT,(string)m_deviation);

//--- description
   ObjectCreate(0,m_descr_dev,OBJ_LABEL,0,0,0);
   ObjectSetInteger(0,m_descr_dev,OBJPROP_XDISTANCE,12);
   ObjectSetInteger(0,m_descr_dev,OBJPROP_YDISTANCE,20);
   ObjectSetInteger(0,m_descr_dev,OBJPROP_XSIZE,80);
   ObjectSetInteger(0,m_descr_dev,OBJPROP_BGCOLOR,clrWhite);
   ObjectSetString(0,m_descr_dev,OBJPROP_TEXT,"Deviation (pips):");
   ObjectSetInteger(0,m_descr_dev,OBJPROP_COLOR,clrBlack);

//--- sl description
   ObjectCreate(0,m_descr_sl,OBJ_LABEL,0,0,0);
   ObjectSetInteger(0,m_descr_sl,OBJPROP_XDISTANCE,12);
   ObjectSetInteger(0,m_descr_sl,OBJPROP_YDISTANCE,40);
   ObjectSetInteger(0,m_descr_sl,OBJPROP_XSIZE,80);
   ObjectSetInteger(0,m_descr_sl,OBJPROP_BGCOLOR,clrWhite);
   ObjectSetString(0,m_descr_sl,OBJPROP_TEXT,"Stop-Loss:");
   ObjectSetInteger(0,m_descr_sl,OBJPROP_COLOR,clrBlack);

//--- sl level
   ObjectCreate(0,m_sl_name,OBJ_EDIT,0,0,0);
   ObjectSetInteger(0,m_sl_name,OBJPROP_XDISTANCE,120);
   ObjectSetInteger(0,m_sl_name,OBJPROP_YDISTANCE,40);
   ObjectSetInteger(0,m_sl_name,OBJPROP_XSIZE,60);
   ObjectSetInteger(0,m_sl_name,OBJPROP_BGCOLOR,clrWhite);
   ObjectSetInteger(0,m_sl_name,OBJPROP_COLOR,clrBlack);
   ObjectSetInteger(0,m_sl_name,OBJPROP_ALIGN,ALIGN_RIGHT);

//--- volume description
   ObjectCreate(0,m_vol_descr,OBJ_LABEL,0,0,0);
   ObjectSetInteger(0,m_vol_descr,OBJPROP_XDISTANCE,12);
   ObjectSetInteger(0,m_vol_descr,OBJPROP_YDISTANCE,60);
   ObjectSetInteger(0,m_vol_descr,OBJPROP_XSIZE,80);
   ObjectSetInteger(0,m_vol_descr,OBJPROP_BGCOLOR,clrWhite);
   ObjectSetString(0,m_vol_descr,OBJPROP_TEXT,"Volume:");
   ObjectSetInteger(0,m_vol_descr,OBJPROP_COLOR,clrBlack);

//--- volume edit
   ObjectCreate(0,m_vol_edit,OBJ_EDIT,0,0,0);
   ObjectSetInteger(0,m_vol_edit,OBJPROP_XDISTANCE,120);
   ObjectSetInteger(0,m_vol_edit,OBJPROP_YDISTANCE,60);
   ObjectSetInteger(0,m_vol_edit,OBJPROP_XSIZE,60);
   ObjectSetInteger(0,m_vol_edit,OBJPROP_BGCOLOR,clrWhite);
   ObjectSetInteger(0,m_vol_edit,OBJPROP_COLOR,clrBlack);
   ObjectSetInteger(0,m_vol_edit,OBJPROP_ALIGN,ALIGN_RIGHT);

//--- sell button
   ObjectCreate(0,m_sell_button_name,OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,m_sell_button_name,OBJPROP_XDISTANCE,10);
   ObjectSetInteger(0,m_sell_button_name,OBJPROP_YDISTANCE,90);
   ObjectSetInteger(0,m_sell_button_name,OBJPROP_XSIZE,80);
   ObjectSetInteger(0,m_sell_button_name,OBJPROP_BGCOLOR,clrPink);
   ObjectSetString(0,m_sell_button_name,OBJPROP_TEXT,"SELL");
   ChartRedraw();

//--- buy button
   ObjectCreate(0,m_buy_button_name,OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,m_buy_button_name,OBJPROP_XDISTANCE,100);
   ObjectSetInteger(0,m_buy_button_name,OBJPROP_YDISTANCE,90);
   ObjectSetInteger(0,m_buy_button_name,OBJPROP_XSIZE,80);
   ObjectSetInteger(0,m_buy_button_name,OBJPROP_BGCOLOR,clrAliceBlue);
   ObjectSetString(0,m_buy_button_name,OBJPROP_TEXT,"BUY");

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CDevPanel::~CDevPanel(void)
  {
   ObjectDelete(0,m_buy_button_name);
   ObjectDelete(0,m_sell_button_name);
   ObjectDelete(0,m_bg_fon);
   ObjectDelete(0,m_deviation_name);
   ObjectDelete(0,m_descr_dev);
   ObjectDelete(0,m_descr_sl);
   ObjectDelete(0,m_sl_name);
   ObjectDelete(0,m_vol_edit);
   ObjectDelete(0,m_vol_descr);
  }
//+------------------------------------------------------------------+
//| Event function                                                   |
//+------------------------------------------------------------------+
void CDevPanel::OnChartEvent(const int id,
                             const long &lparam,
                             const double &dparam,
                             const string &sparam)
  {
   switch(id)
     {
      case CHARTEVENT_OBJECT_CLICK:
         OnObjClick(sparam);
         break;
      case CHARTEVENT_OBJECT_ENDEDIT:
         OnEndEdit(sparam);
     }
  }
//+------------------------------------------------------------------+
//| End edit detect                                                  |
//+------------------------------------------------------------------+
void CDevPanel::OnEndEdit(string sparam)
  {
//--- edit deviation level
   if(sparam==m_deviation_name)
     {
      int value = (int)ObjectGetString(0, m_deviation_name, OBJPROP_TEXT);
      if(value <= 0)
         ObjectSetString(0,m_deviation_name,OBJPROP_TEXT,(string)m_deviation);
      else
         m_deviation=value;
     }
//--- edit sl level
   else if(sparam==m_sl_name)
     {
      string str = ObjectGetString(0, m_sl_name, OBJPROP_TEXT);
      m_sl_level = MathAbs(StringToDouble(str));
      string val = m_sl_level > 0 ? DoubleToString(m_sl_level, Digits()) : "";
      ObjectSetString(0,m_sl_name,OBJPROP_TEXT,val);
     }
   else if(sparam==m_vol_edit)
     {
      string str=ObjectGetString(0,m_vol_edit,OBJPROP_TEXT);
      m_volume=MathAbs(StringToInteger(str));
      string val=m_volume>0 ?(string)m_volume : "";
      ObjectSetString(0,m_vol_edit,OBJPROP_TEXT,val);
     }
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//| End obj click                                                    |
//+------------------------------------------------------------------+
void CDevPanel::OnObjClick(string sparam)
  {
   if(sparam==m_buy_button_name)
     {
      if(Trade.BuyLimit(1,CalcCurrentPrice(OP_BUY)))
         SendStopLoss(OP_BUY);
     }
   if(sparam==m_sell_button_name)
     {
      if(Trade.SellLimit(1,CalcCurrentPrice(OP_SELL)))
         SendStopLoss(OP_SELL);
     }
   ObjectSetInteger(0,sparam,OBJPROP_STATE,false);
   Sleep(100);
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//| Calc level price                                                 |
//+------------------------------------------------------------------+
double CDevPanel::CalcCurrentPrice(int op_type)
  {
   if(op_type==OP_BUY)
     {
      double ask=SymbolInfoDouble(Symbol(),SYMBOL_ASK);
      return ask + (m_deviation * Point());
     }
   else if(op_type==OP_SELL)
     {
      double bid=SymbolInfoDouble(Symbol(),SYMBOL_BID);
      return bid - (m_deviation * Point());
     }
   return 0.0;
  }
//+------------------------------------------------------------------+
//| Send SL order                                                    |
//+------------------------------------------------------------------+
bool CDevPanel::SendStopLoss(int op_type)
  {
   if(op_type==OP_BUY)
     {
      double bid=SymbolInfoDouble(Symbol(),SYMBOL_BID);
      if(m_sl_level>=0.0 && m_sl_level<bid)
        {
         MqlTradeRequest request={0};
         request.action = TRADE_ACTION_PENDING;
         request.symbol = Symbol();
         request.volume = 1.0;
         request.price=m_sl_level;
         request.stoplimit=m_sl_level -(m_deviation*Point());
         request.type=ORDER_TYPE_SELL_STOP_LIMIT;
         request.type_filling=ORDER_FILLING_RETURN;
         request.type_time=ORDER_TIME_DAY;
         MqlTradeResult result;
         bool res=OrderSend(request,result);
         if(!res)
            Print("Error set S/L. Reason: "+(string)GetLastError());
         return res;
        }
     }
   else if(op_type==OP_SELL)
     {
      double ask=SymbolInfoDouble(Symbol(),SYMBOL_ASK);
      if(m_sl_level>=0.0 && m_sl_level>ask)
        {
         MqlTradeRequest request={0};
         request.action = TRADE_ACTION_PENDING;
         request.symbol = Symbol();
         request.volume = 1.0;
         request.price=m_sl_level;
         request.stoplimit=m_sl_level+(m_deviation*Point());
         request.type=ORDER_TYPE_BUY_STOP_LIMIT;
         request.type_filling=ORDER_FILLING_RETURN;
         request.type_time=ORDER_TIME_DAY;
         MqlTradeResult result;
         bool res=OrderSend(request,result);
         if(!res)
            Print("Error set S/L. Reason: "+(string)GetLastError());
         return res;
        }

     }
   return false;
  }
//+------------------------------------------------------------------+
//| Book event notice                                                |
//+------------------------------------------------------------------+
void CDevPanel::OnBookEvent(string symbol)
  {
   if(symbol != Symbol())return;
   MarketBook.Refresh();
   if(m_volume == 0)return;
   double dev_buy=MarketBook.GetDeviationByVol(m_volume,MBOOK_ASK);
   double dev_sell=MarketBook.GetDeviationByVol(m_volume,MBOOK_BID);
   double points=SymbolInfoDouble(Symbol(),SYMBOL_POINT);
   dev_buy=dev_buy/SymbolInfoDouble(Symbol(),SYMBOL_POINT);
   dev_sell=dev_sell/SymbolInfoDouble(Symbol(),SYMBOL_POINT);
   string sdev_buy="BUY ("+DoubleToString(dev_buy,0)+")";
   string sdev_sell="SELL ("+DoubleToString(dev_sell,0)+")";
   ObjectSetString(0,m_sell_button_name,OBJPROP_TEXT,sdev_sell);
   ObjectSetString(0,m_buy_button_name,OBJPROP_TEXT,sdev_buy);
   ChartRedraw();
  }
//+------------------------------------------------------------------+
